pcl::CropBox< PointT > Class Template Reference
Module filters

CropBox is a filter that allows the user to filter all the data inside of a given box. More...

`#include <pcl/filters/crop_box.h>`

Inheritance diagram for pcl::CropBox< PointT >:

## Public Types

typedef boost::shared_ptr< CropBox< PointT > > | Ptr
typedef boost::shared_ptr< const CropBox< PointT > > | ConstPtr
Public Types inherited from pcl::FilterIndices< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef boost::shared_ptr< FilterIndices< PointT > > | Ptr
typedef boost::shared_ptr< const FilterIndices< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| CropBox (bool extract_removed_indices=false)
| Constructor. More...
void | setMin (const Eigen::Vector4f &min_pt)
| Set the minimum point of the box. More...
Eigen::Vector4f | getMin () const
| Get the value of the minimum point of the box, as set by the user. More...
void | setMax (const Eigen::Vector4f &max_pt)
| Set the maximum point of the box. More...
Eigen::Vector4f | getMax () const
| Get the value of the maxiomum point of the box, as set by the user. More...
void | setTranslation (const Eigen::Vector3f &translation)
| Set a translation value for the box. More...
Eigen::Vector3f | getTranslation () const
| Get the value of the box translation parameter as set by the user. More...
void | setRotation (const Eigen::Vector3f &rotation)
| Set a rotation value for the box. More...
Eigen::Vector3f | getRotation () const
| Get the value of the box rotatation parameter, as set by the user. More...
void | setTransform (const Eigen::Affine3f &transform)
| Set a transformation that should be applied to the cloud before filtering. More...
Eigen::Affine3f | getTransform () const
| Get the value of the transformation parameter, as set by the user. More...
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
void | filter (PointCloud &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | applyFilter (PointCloud &output)
| Sample of point indices into a separate PointCloud. More...
void | applyFilter (std::vector< int > &indices)
| Sample of point indices. More...
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::CropBox< PointT >

CropBox is a filter that allows the user to filter all the data inside of a given box.

Author
  Justin Rosen

Definition at line 57 of file crop_box.h.

## Member Typedef Documentation

template<typename PointT >

typedef boost::shared_ptr< const CropBox<PointT> > pcl::CropBox< PointT >::ConstPtr

Definition at line 68 of file crop_box.h.

template<typename PointT >

typedef boost::shared_ptr< CropBox<PointT> > pcl::CropBox< PointT >::Ptr

Definition at line 67 of file crop_box.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::CropBox< PointT >::CropBox | ( | bool | extract_removed_indices = `false` | ) |

inline

Constructor.

Parameters

  [in] | extract_removed_indices | Set to true if you want to be able to extract the indices of points being removed (default = false).

Definition at line 73 of file crop_box.h.

References pcl::Filter< PointT >::filter_name_.

## Member Function Documentation

template<typename PointT >

void pcl::CropBox< PointT >::applyFilter | ( | PointCloud & | output | ) |

protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  [out] | output | the resultant point cloud

Implements pcl::FilterIndices< PointT >.

Definition at line 48 of file crop_box.hpp.

References pcl::copyPointCloud(), pcl::PointCloud< PointT >::is_dense, and pcl::PointCloud< PointT >::points.

Referenced by pcl::CropBox< PointT >::getTransform(), and pcl::CropBox< pcl::PCLPointCloud2 >::getTransform().

template<typename PointT >

void pcl::CropBox< PointT >::applyFilter | ( | std::vector< int > & | indices | ) |

protected virtual

Sample of point indices.

Parameters

  [out] | indices | the resultant point cloud indices

Implements pcl::FilterIndices< PointT >.

Definition at line 74 of file crop_box.hpp.

References pcl::getTransformation(), and pcl::isFinite().

template<typename PointT >

Eigen::Vector4f pcl::CropBox< PointT >::getMax | ( |  | ) | const

inline

Get the value of the maxiomum point of the box, as set by the user.

Returns
  the value of the internal max_pt parameter.

Definition at line 115 of file crop_box.h.

template<typename PointT >

Eigen::Vector4f pcl::CropBox< PointT >::getMin | ( |  | ) | const

inline

Get the value of the minimum point of the box, as set by the user.

Returns
  the value of the internal min_pt parameter.

Definition at line 97 of file crop_box.h.

template<typename PointT >

Eigen::Vector3f pcl::CropBox< PointT >::getRotation | ( |  | ) | const

inline

Get the value of the box rotatation parameter, as set by the user.

Definition at line 147 of file crop_box.h.

template<typename PointT >

Eigen::Affine3f pcl::CropBox< PointT >::getTransform | ( |  | ) | const

inline

Get the value of the transformation parameter, as set by the user.

Definition at line 163 of file crop_box.h.

References pcl::CropBox< PointT >::applyFilter().

template<typename PointT >

Eigen::Vector3f pcl::CropBox< PointT >::getTranslation | ( |  | ) | const

inline

Get the value of the box translation parameter as set by the user.

Definition at line 131 of file crop_box.h.

template<typename PointT >

void pcl::CropBox< PointT >::setMax | ( | const Eigen::Vector4f & | max_pt | ) |

inline

Set the maximum point of the box.

Parameters

  [in] | max_pt | the maximum point of the box

Definition at line 106 of file crop_box.h.

template<typename PointT >

void pcl::CropBox< PointT >::setMin | ( | const Eigen::Vector4f & | min_pt | ) |

inline

Set the minimum point of the box.

Parameters

  [in] | min_pt | the minimum point of the box

Definition at line 88 of file crop_box.h.

template<typename PointT >

void pcl::CropBox< PointT >::setRotation | ( | const Eigen::Vector3f & | rotation | ) |

inline

Set a rotation value for the box.

Parameters

  [in] | rotation | the (rx,ry,rz) values that the box should be rotated by

Definition at line 140 of file crop_box.h.

template<typename PointT >

void pcl::CropBox< PointT >::setTransform | ( | const Eigen::Affine3f & | transform | ) |

inline

Set a transformation that should be applied to the cloud before filtering.

Parameters

  [in] | transform | an affine transformation that needs to be applied to the cloud before filtering

Definition at line 156 of file crop_box.h.

template<typename PointT >

void pcl::CropBox< PointT >::setTranslation | ( | const Eigen::Vector3f & | translation | ) |

inline

Set a translation value for the box.

Parameters

  [in] | translation | the (tx,ty,tz) values that the box should be translated by

Definition at line 124 of file crop_box.h.

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/filters/include/pcl/filters/crop_box.h
- /build/pcl-6_P28C/pcl-1.7.2/filters/include/pcl/filters/impl/crop_box.hpp